LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
  
ENTITY testbench_servo IS
END testbench_servo;
 
ARCHITECTURE behavior OF testbench_servo IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT servo
    PORT(
         CLOCK_6MHZ : IN  std_logic;
         LINKS : IN  std_logic;
         RECHTS : IN  std_logic;
         PWM : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal CLOCK_6MHZ : std_logic := '0';
   signal LINKS : std_logic := '0';
   signal RECHTS : std_logic := '0';

 	--Outputs
   signal PWM : std_logic;

   -- Clock period definitions
   constant CLOCK_6MHZ_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: servo PORT MAP (
          CLOCK_6MHZ => CLOCK_6MHZ,
          LINKS => LINKS,
          RECHTS => RECHTS,
          PWM => PWM
        );

   -- Clock process definitions
   CLOCK_6MHZ_process :process
   begin
		CLOCK_6MHZ <= '0';
		wait for CLOCK_6MHZ_period/2;
		CLOCK_6MHZ <= '1';
		wait for CLOCK_6MHZ_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for CLOCK_6MHZ_period*100;

      -- insert stimulus here 
      LINKS <= '0';
      RECHTS <= '0';      
      wait for 100 ms;	
      RECHTS <= '0';      
      LINKS <= '1';
      wait for 100 ms;	
      LINKS <= '0';
      RECHTS <= '1';      
      wait for 100 ms;	
		
      wait;
   end process;

END;
